<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- filetagger.qdoc -->
  <title>FileTagger QML Type | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="qml-qbslanguageitems-export.html" />
  <link rel="next" href="qml-qbslanguageitems-group.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="qml-qbslanguageitems-export.html">Export</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="qml-qbslanguageitems-group.html">Group</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#properties">Properties</a></li>
<li class="level1"><a href="#details">Detailed Description</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">FileTagger QML Type</h1>
<span class="subtitle"></span>
<!-- $$$FileTagger-brief -->
<p>Assigns file tags to files. <a href="#details">More...</a></p>
<!-- @@@FileTagger -->
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> Import Statement:</td><td class="memItemRight bottomAlign"> import QbsLanguageItems .</td></tr></table></div><ul>
<li><a href="qml-qbslanguageitems-filetagger-members.html">List of all members, including inherited members</a></li>
</ul>
<a name="properties"></a>
<h2 id="properties">Properties</h2>
<ul>
<li class="fn"><b><b><a href="qml-qbslanguageitems-filetagger.html#fileTags-prop">fileTags</a></b></b> : list</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-filetagger.html#patterns-prop">patterns</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-filetagger.html#priority-prop">priority</a></b></b> : int</li>
</ul>
<!-- $$$FileTagger-description -->
<a name="details"></a>
<h2 id="details">Detailed Description</h2>
<p>This item assigns file tags to files. The FileTagger item can appear in <a href="qml-qbslanguageitems-product.html">Product</a> items or <a href="qml-qbslanguageitems-module.html">Module</a> items.</p>
<p>For every source artifact that has no file tag, Qbs will search for a FileTagger with a pattern that matches the file name of the source artifact. If a matching file tagger is found, then the file tags specified in the FileTagger item are assigned to the source artifact.</p>
<p>If there is more than one matching FileTagger, all file taggers with the same highest priority are taken into account and their file tags are accumulated.</p>
<p>The FileTagger item can be attached to a product or a module. In the latter case, its effect is the same as if it had been attached to all products having a dependency on the respective module. For instance, the <a href="qml-qbsmodules-cpp.html">cpp</a> module of Qbs has, among others, the following file tagger:</p>
<pre class="cpp">

  FileTagger {
      patterns: <span class="string">&quot;*.cpp&quot;</span>
      fileTags: <span class="operator">[</span><span class="string">&quot;cpp&quot;</span><span class="operator">]</span>
  }

</pre>
<p>As a result, the <code>&quot;cpp&quot;</code> tag is automatically attached to all files ending with <code>&quot;.cpp&quot;</code> in products depending on the <code>cpp</code> module. This causes them to be compiled, because a C++ compiler rule has <code>&quot;cpp&quot;</code> in its list of matching input tags.</p>
<p>File taggers are disabled if file tags are set explicitly in a <a href="qml-qbslanguageitems-product.html">product</a> or <a href="qml-qbslanguageitems-group.html">group</a>. For example, the <code>&quot;cpp&quot;</code> tag is not attached to the <code>.cpp</code> files in the following product:</p>
<pre class="cpp">

  Product {
      Depends { name: <span class="string">&quot;cpp&quot;</span> }
      Group {
          files: <span class="string">&quot;*.cpp&quot;</span>
          fileTags: <span class="string">&quot;other&quot;</span>
      }
  }

</pre>
<!-- @@@FileTagger -->
<h2>Property Documentation</h2>
<!-- $$$fileTags -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="fileTags-prop">
<td class="tblQmlPropNode"><p>
<span class="name">fileTags</span> : <span class="type">list</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>Tags to attach to a product's files. These can then be matched by a rule.</p>
<p>Default: An empty list</p>
<p>This property was introduced in Qbs 1.0.</p>
</div></div><!-- @@@fileTags -->
<br/>
<!-- $$$patterns -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="patterns-prop">
<td class="tblQmlPropNode"><p>
<span class="name">patterns</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A list of patterns to match against. Supports the usual wildcards '*', '?' and '[]'.</p>
<p>Neither the list itself nor any of its elements may be empty.</p>
<p>This property was introduced in Qbs 1.0.</p>
</div></div><!-- @@@patterns -->
<br/>
<!-- $$$priority -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="priority-prop">
<td class="tblQmlPropNode"><p>
<span class="name">priority</span> : <span class="type">int</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The priority of the <a href="qml-qbslanguageitems-filetagger.html">FileTagger</a>. A higher numerical value means a higher priority.</p>
<p>Default: 0</p>
<p>This property was introduced in Qbs 1.10.</p>
</div></div><!-- @@@priority -->
<br/>
<p class="naviNextPrevious footerNavi">
<a class="prevPage" href="qml-qbslanguageitems-export.html">Export</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="qml-qbslanguageitems-group.html">Group</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
